package com.sencorsta.rabs.obj.ai.scene.family;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;

import java.awt.*;

/**
 * 组织-信息
 */
@SceneAnnotation("SceneMain_Family_Out")
public class SceneMain_Family_Out_Fight extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 3.0f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\family\\out\\fight\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\family\\out\\fight\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\family\\out\\fight\\back.png";
    private static String PathStart = System.getProperty("user.dir") + "\\opencv\\scene\\family\\out\\fight\\start.png";
    private static String PathSkip = System.getProperty("user.dir") + "\\opencv\\scene\\family\\out\\fight\\skip.png";
    private static String PathOver = System.getProperty("user.dir") + "\\opencv\\scene\\family\\out\\fight\\over.png";


    @Override
    public void back() throws AWTException {
        isTempDone = false;
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(5000);
                continue;
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @JsonIgnore
    static int maxTime = 3;

    @Override
    public void think() throws AWTException {
        int count = getRecord().getData().getCount();

        ThreadUtil.sleep(2000);
        moveToClick(PathStart, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(2000);

        while (AiManage.getInstance().isRunning() && !checkHas(PathOver, AiManage.getInstance().getCheckPoint())) {
            if (checkHas(PathSkip, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathSkip, AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(2000);
            }
            if (checkHas(PathStart, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathStart, AiManage.getInstance().getCheckPoint());
                ThreadUtil.sleep(2000);
            }
            ThreadUtil.sleep(1000);
        }

        moveToClick(PathOver, AiManage.getInstance().getCheckPoint());
        ThreadUtil.sleep(6000);


        getRecord().getData().setCount(count + 1);
        isTempDone = true;
    }

    @Override
    public boolean isDone() {
        if (getRecord().getData().getCount() >= maxTime) {
            return true;
        }
        return isTempDone;
    }

}
